/*

    3DKIT   version   1.3
    High speed 3D graphics and rendering library for Linux.

    Copyright (C) 1996, 1997  Paul Sheer   psheer@icon.co.za

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
    MA 02111-1307, USA

*/

#ifndef QUICK_MATH_H
#define QUICK_MATH_H

#if 0
#ifndef SVGALIB
#include "../config.h"
#endif
#endif

#ifndef PI
#define PI 3.14159265358979323846
#endif

typedef struct {
    double x, y, z;
} Vec;


#define sqr(x) ((x)*(x))

#define fswap(a, b) \
{ \
    double __t_var = (a); \
    (a) = (b); \
    (b) = __t_var; \
}


#define swap(a, b) \
{ \
    int __t_var = (a); \
    (a) = (b); \
    (b) = __t_var; \
}

#define max(x,y)     (((x) > (y)) ? (x) : (y))
#define min(x,y)     (((x) < (y)) ? (x) : (y))

#ifndef __GNUC__

double fsqr (double x);
int lsqr (int x);
double fmax (double a, double b);
double fmin (double a, double b);
double fsgn (double a);
double dot (Vec a, Vec b);
Vec cross (Vec a, Vec b);
Vec plus (Vec a, Vec b);
Vec minus (Vec a, Vec b);
Vec times (Vec a, double f);
double norm (Vec a);

#else

extern inline double fsqr (double x);
extern inline int lsqr (int x);
extern inline double fmax (double a, double b);
extern inline double fmin (double a, double b);
extern inline double fsgn (double a);
extern inline double dot (Vec a, Vec b);
extern inline Vec cross (Vec a, Vec b);
extern inline Vec plus (Vec a, Vec b);
extern inline Vec minus (Vec a, Vec b);
extern inline Vec times (Vec a, double f);
extern inline double norm (Vec a);

#endif

void orth_vectors (Vec X, Vec * r1, Vec * r2, double r);

#endif

